using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;

namespace CubeSlide
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        #region Variables
        
        
        int mx = 0;    // mouse horizontal pixel position
        int my = 0;    // mouse vertical position
        int bx = 0;   // column number of mouse
        int by = 0;   // row number of mouse
        int oldx = 0;
        int oldy = 0;
        int mx2 = 0;    // mouse horizontal pixel position on level 2
        int my2 = 0;    // mouse vertical position
        int bx2 = 0;   // column number of mouse
        int by2 = 0;   // row number of mouse
        int bsize = 56; // square size
        int cnt = 0;  // counters
        int cnt2 = 0;
        int cnt3 = 0;
        int cnt4 = 0;
        int color1 = 0;
        int color2 = 0;
        int p1 = 0;
        int c1 = 0;
        int c2 = 0;
        int c3 = 0;
        int c4 = 0;
        int p2 = 0;
        int c11 = 0;
        int c12 = 0;
        int c13 = 0;
        int c14 = 0;
        int r1 = 1;  // random numbers or holders of array data
        int r2 = 2;
        int r3 = 3;
        int r4 = 4;
        int r5 = 1;
        int move = 1;
        int score = 0;
        int gameover = 0;
        Random rnd = new Random();
        int[,] brd = new int[60, 60];  // Array for holding piece information 
        int[,] brd2 = new int[60, 60]; // layer 2
        int[,] brd3 = new int[60, 60]; // layer 3
        int[,] brd4 = new int[60, 60]; // layer 4
        int[,] piececolor = new int[40, 6];
        #endregion
        #region Pens Fonts and Brushes


        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(100, 100, 150));
        Brush br3 = new SolidBrush(Color.FromArgb(0, 0, 250));
        Brush br4 = new SolidBrush(Color.LightSlateGray);
        Brush br5 = new SolidBrush(Color.DarkSlateGray);
        Brush bck = new SolidBrush(Color.FromArgb(50, 50, 90));
        Brush redbr = new SolidBrush(Color.Red);        // 1
        Brush greenbr = new SolidBrush(Color.Green);    //2
        Brush bluebr = new SolidBrush(Color.Blue);      //3
        Brush yellowbr = new SolidBrush(Color.Yellow);  //4
        Brush orangebr = new SolidBrush(Color.Orange);  //5

        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        Pen bluepen = new Pen(Color.Blue);
        Pen whitepen = new Pen(Color.White);
        Pen redpen = new Pen(Color.Red);
        #endregion
        #region Bitmaps


        static Bitmap bmp1 = new Bitmap(800, 600);
        Graphics z = Graphics.FromImage(bmp1);

        static Bitmap bm1 = new Bitmap(54, 54);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(54, 54);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(54, 54);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(54, 54);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(54, 54);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(54, 54);
        Graphics b6 = Graphics.FromImage(bm6);
        static Bitmap bm7 = new Bitmap(54, 54);
        Graphics b7 = Graphics.FromImage(bm7);
        static Bitmap bm8 = new Bitmap(54, 54);
        Graphics b8 = Graphics.FromImage(bm8);
        static Bitmap bm9 = new Bitmap(54, 54);
        Graphics b9 = Graphics.FromImage(bm9);
        static Bitmap bm10 = new Bitmap(54, 54);
        Graphics b10 = Graphics.FromImage(bm10);
        static Bitmap bm11 = new Bitmap(54, 54);
        Graphics b11 = Graphics.FromImage(bm11);
        static Bitmap bm12 = new Bitmap(54, 54);
        Graphics b12 = Graphics.FromImage(bm12);
        static Bitmap bm13 = new Bitmap(54, 54);
        Graphics b13 = Graphics.FromImage(bm13);
        static Bitmap bm14 = new Bitmap(54, 54);
        Graphics b14 = Graphics.FromImage(bm14);
        static Bitmap bm15 = new Bitmap(54, 54);
        Graphics b15 = Graphics.FromImage(bm15);
        static Bitmap bm16 = new Bitmap(54, 54);
        Graphics b16 = Graphics.FromImage(bm16);
        static Bitmap bm17 = new Bitmap(54, 54);
        Graphics b17 = Graphics.FromImage(bm17);
        static Bitmap bm18 = new Bitmap(54, 54);
        Graphics b18 = Graphics.FromImage(bm18);
        static Bitmap bm19 = new Bitmap(54, 54);
        Graphics b19 = Graphics.FromImage(bm19);
        static Bitmap bm20 = new Bitmap(54, 54);
        Graphics b20 = Graphics.FromImage(bm20);
        static Bitmap bm21 = new Bitmap(54, 54);
        Graphics b21 = Graphics.FromImage(bm21);
        static Bitmap bm22 = new Bitmap(54, 54);
        Graphics b22 = Graphics.FromImage(bm22);
        static Bitmap bm23 = new Bitmap(54, 54);
        Graphics b23 = Graphics.FromImage(bm23);
        static Bitmap bm24 = new Bitmap(54, 54);
        Graphics b24 = Graphics.FromImage(bm24);
        static Bitmap bm25 = new Bitmap(54, 54);
        Graphics b25 = Graphics.FromImage(bm25);
        static Bitmap bm26 = new Bitmap(54, 54);
        Graphics b26 = Graphics.FromImage(bm26);
        static Bitmap bm27 = new Bitmap(54, 54);
        Graphics b27 = Graphics.FromImage(bm27);
        static Bitmap bm28 = new Bitmap(54, 54);
        Graphics b28 = Graphics.FromImage(bm28);
        static Bitmap bm29 = new Bitmap(54, 54);
        Graphics b29 = Graphics.FromImage(bm29);
        static Bitmap bm30 = new Bitmap(54, 54);
        Graphics b30 = Graphics.FromImage(bm30);
        static Bitmap bm31 = new Bitmap(54, 54);
        Graphics b31 = Graphics.FromImage(bm31);
        static Bitmap bm32 = new Bitmap(54, 54);
        Graphics b32 = Graphics.FromImage(bm32);
        static Bitmap bm33 = new Bitmap(54, 54);
        Graphics b33 = Graphics.FromImage(bm33);
        static Bitmap bm34 = new Bitmap(54, 54);
        Graphics b34 = Graphics.FromImage(bm34);
        static Bitmap bm35 = new Bitmap(54, 54);
        Graphics b35 = Graphics.FromImage(bm35);
        static Bitmap bm36 = new Bitmap(54, 54);
        Graphics b36 = Graphics.FromImage(bm36);
        #endregion
        private void Form1_Load(object sender, EventArgs e)
        {
            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);
            MakeSprites();
            Setup();
            UpdateScreen();

        }
        private void MakeBoard() // size 56 8x
        {
            int x = 0;
            int y = 0;
            int a = 0;
            z.FillRectangle(br5, 210, 42, 476, 476);
            z.FillRectangle(redbr, 218, 50, 460, 460);
            z.FillRectangle(br4, 220, 52, 456, 456);
            
            while (a < 9)
            {
                z.DrawLine(whitepen, 224+x, 56, 224+x, 504); // vertical
                a = a + 1;
                x = x + 56;
            }
            a = 0;
            while (a < 9)
            {
                z.DrawLine(whitepen, 224 , 56+y, 672, 56+y); // horizontal
                a = a + 1;
                y = y + 56;
            }
        }
        private void MakeSprites()
        {
            
            b1.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b1.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b1.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b1.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            PointF[] pt1 = { new PointF(29,27), new PointF(50, 5), new PointF(50, 47) };
            b1.FillPolygon(redbr, pt1);
            PointF[] pt2 = { new PointF(8, 5), new PointF(45, 5), new PointF(27, 24) };
            b1.FillPolygon(greenbr, pt2);
            PointF[] pt3 = { new PointF(27, 29), new PointF(48, 50), new PointF(5, 50) };
            b1.FillPolygon(bluebr, pt3);
            PointF[] pt4 = { new PointF(5, 7), new PointF(25,26), new PointF(5, 46) };
            b1.FillPolygon(yellowbr, pt4);
            piececolor[1, 1] = 1;
            piececolor[1, 2] = 2;
            piececolor[1, 3] = 3;
            piececolor[1, 4] = 4;

            b2.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b2.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b2.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b2.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            b2.FillPolygon(redbr, pt1);   // right   red=1 green=2 blue=3 yellow=4 orange=5
            b2.FillPolygon(yellowbr, pt2); // top
            b2.FillPolygon(bluebr, pt3);  // bottom
            b2.FillPolygon(greenbr, pt4); // left
            piececolor[2, 1] = 1;
            piececolor[2, 2] = 4;
            piececolor[2, 3] = 3;
            piececolor[2, 4] = 2;

            b3.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b3.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b3.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b3.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b3.FillPolygon(redbr, pt1);
            b3.FillPolygon(bluebr, pt2);
            b3.FillPolygon(greenbr, pt3);
            b3.FillPolygon(yellowbr, pt4);
            piececolor[3, 1] = 1;
            piececolor[3, 2] = 3;
            piececolor[3, 3] = 2;
            piececolor[3, 4] = 4;

            b4.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b4.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b4.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b4.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b4.FillPolygon(redbr, pt1);
            b4.FillPolygon(greenbr, pt2);
            b4.FillPolygon(bluebr, pt3);
            b4.FillPolygon(greenbr, pt4);
            piececolor[4, 1] = 1;
            piececolor[4, 2] = 2;
            piececolor[4, 3] = 3;
            piececolor[4, 4] = 2;

            b5.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b5.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b5.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b5.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b5.FillPolygon(bluebr, pt1);
            b5.FillPolygon(yellowbr, pt2);
            b5.FillPolygon(redbr, pt3);
            b5.FillPolygon(yellowbr, pt4);
            piececolor[5, 1] = 3;
            piececolor[5, 2] = 4;
            piececolor[5, 3] = 1;
            piececolor[5, 4] = 4;

            b6.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b6.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b6.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b6.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b6.FillPolygon(bluebr, pt1);
            b6.FillPolygon(redbr, pt2);
            b6.FillPolygon(yellowbr, pt3);
            b6.FillPolygon(greenbr, pt4);
            piececolor[6, 1] = 3;
            piececolor[6, 2] = 1;
            piececolor[6, 3] = 4;
            piececolor[6, 4] = 2;

            b7.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b7.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b7.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b7.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b7.FillPolygon(bluebr, pt1);
            b7.FillPolygon(greenbr, pt2);
            b7.FillPolygon(yellowbr, pt3);
            b7.FillPolygon(redbr, pt4);
            piececolor[7, 1] = 3;
            piececolor[7, 2] = 2;
            piececolor[7, 3] = 3;
            piececolor[7, 4] = 1;

            b8.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b8.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b8.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b8.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b8.FillPolygon(bluebr, pt1);
            b8.FillPolygon(yellowbr, pt2);
            b8.FillPolygon(redbr, pt3);
            b8.FillPolygon(greenbr, pt4);
            piececolor[8, 1] = 3;
            piececolor[8, 2] = 4;
            piececolor[8, 3] = 1;
            piececolor[8, 4] = 2;

            b9.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b9.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b9.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b9.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b9.FillPolygon(greenbr, pt1);
            b9.FillPolygon(redbr, pt2);
            b9.FillPolygon(bluebr, pt3);
            b9.FillPolygon(yellowbr, pt4);
            piececolor[9, 1] = 2;
            piececolor[9, 2] = 1;
            piececolor[9, 3] = 3;
            piececolor[9, 4] = 4;

            b10.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b10.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b10.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b10.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b10.FillPolygon(greenbr, pt1);
            b10.FillPolygon(bluebr, pt2);
            b10.FillPolygon(yellowbr, pt3);
            b10.FillPolygon(redbr, pt4);
            piececolor[10, 1] = 2;
            piececolor[10, 2] = 3;
            piececolor[10, 3] = 2;
            piececolor[10, 4] = 1;

            b11.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b11.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b11.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b11.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b11.FillPolygon(greenbr, pt1);
            b11.FillPolygon(redbr, pt2);
            b11.FillPolygon(bluebr, pt3);
            b11.FillPolygon(yellowbr, pt4);
            piececolor[11, 1] = 2;
            piececolor[11, 2] = 1;
            piececolor[11, 3] = 3;
            piececolor[11, 4] = 4;

            b12.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b12.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b12.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b12.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b12.FillPolygon(greenbr, pt1);
            b12.FillPolygon(greenbr, pt2);
            b12.FillPolygon(bluebr, pt3);
            b12.FillPolygon(yellowbr, pt4);
            piececolor[12, 1] = 2;
            piececolor[12, 2] = 2;
            piececolor[12, 3] = 3;
            piececolor[12, 4] = 4;

            b13.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b13.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b13.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b13.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b13.FillPolygon(yellowbr, pt1);
            b13.FillPolygon(greenbr, pt2);
            b13.FillPolygon(bluebr, pt3);
            b13.FillPolygon(redbr, pt4);
            piececolor[13, 1] = 4;
            piececolor[13, 2] = 2;
            piececolor[13, 3] = 3;
            piececolor[13, 4] = 1;

            b14.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b14.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b14.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b14.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b14.FillPolygon(yellowbr, pt1);
            b14.FillPolygon(greenbr, pt2);
            b14.FillPolygon(redbr, pt3);
            b14.FillPolygon(bluebr, pt4);
            piececolor[14, 1] = 4;
            piececolor[14, 2] = 2;
            piececolor[14, 3] = 1;
            piececolor[14, 4] = 3;

            b15.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b15.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b15.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b15.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b15.FillPolygon(yellowbr, pt1);
            b15.FillPolygon(greenbr, pt2);
            b15.FillPolygon(bluebr, pt3);
            b15.FillPolygon(greenbr, pt4);
            piececolor[15, 1] = 4;
            piececolor[15, 2] = 2;
            piececolor[15, 3] = 3;
            piececolor[15, 4] = 2;

            b16.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b16.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b16.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b16.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b16.FillPolygon(yellowbr, pt1);
            b16.FillPolygon(greenbr, pt2);
            b16.FillPolygon(greenbr, pt3);
            b16.FillPolygon(bluebr, pt4);
            piececolor[16, 1] = 4;
            piececolor[16, 2] = 2;
            piececolor[16, 3] = 2;
            piececolor[16, 4] = 3;

            b17.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b17.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b17.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b17.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b17.FillPolygon(bluebr, pt1);
            b17.FillPolygon(greenbr, pt2);
            b17.FillPolygon(bluebr, pt3);
            b17.FillPolygon(yellowbr, pt4);
            piececolor[17, 1] = 3;
            piececolor[17, 2] = 2;
            piececolor[17, 3] = 3;
            piececolor[17, 4] = 4;

            b18.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b18.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b18.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b18.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b18.FillPolygon(greenbr, pt1);
            b18.FillPolygon(redbr, pt2);
            b18.FillPolygon(bluebr, pt3);
            b18.FillPolygon(yellowbr, pt4);
            piececolor[18, 1] = 2;
            piececolor[18, 2] = 1;
            piececolor[18, 3] = 3;
            piececolor[18, 4] = 4;

            b19.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b19.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b19.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b19.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b19.FillPolygon(yellowbr, pt1);
            b19.FillPolygon(greenbr, pt2);
            b19.FillPolygon(bluebr, pt3);
            b19.FillPolygon(redbr, pt4);
            piececolor[19, 1] = 4;
            piececolor[19, 2] = 2;
            piececolor[19, 3] = 3;
            piececolor[19, 4] = 1;

            b20.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b20.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b20.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b20.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b20.FillPolygon(yellowbr, pt1);
            b20.FillPolygon(greenbr, pt2);
            b20.FillPolygon(redbr, pt3);
            b20.FillPolygon(bluebr, pt4);
            piececolor[20, 1] = 4;
            piececolor[20, 2] = 2;
            piececolor[20, 3] = 1;
            piececolor[20, 4] = 3;

            b21.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b21.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b21.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b21.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b21.FillPolygon(redbr, pt1);
            b21.FillPolygon(bluebr, pt2);
            b21.FillPolygon(greenbr, pt3);
            b21.FillPolygon(yellowbr, pt4);
            piececolor[21, 1] = 1;
            piececolor[21, 2] = 3;
            piececolor[21, 3] = 2;
            piececolor[21, 4] = 4;

            b22.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b22.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b22.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b22.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b22.FillPolygon(yellowbr, pt1);
            b22.FillPolygon(bluebr, pt2);
            b22.FillPolygon(greenbr, pt3);
            b22.FillPolygon(redbr, pt4);
            piececolor[22, 1] = 4;
            piececolor[22, 2] = 3;
            piececolor[22, 3] = 2;
            piececolor[22, 4] = 1;

            b23.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b23.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b23.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b23.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b23.FillPolygon(greenbr, pt1);
            b23.FillPolygon(bluebr, pt2);
            b23.FillPolygon(yellowbr, pt3);
            b23.FillPolygon(redbr, pt4);
            piececolor[23, 1] = 2;
            piececolor[23, 2] = 3;
            piececolor[23, 3] = 4;
            piececolor[23, 4] = 1;

            b24.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b24.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b24.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b24.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b24.FillPolygon(bluebr, pt1);
            b24.FillPolygon(greenbr, pt2);
            b24.FillPolygon(yellowbr, pt3);
            b24.FillPolygon(redbr, pt4);
            piececolor[24, 1] = 3;
            piececolor[24, 2] = 2;
            piececolor[24, 3] = 4;
            piececolor[24, 4] = 1;

            b25.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b25.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b25.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b25.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b25.FillPolygon(yellowbr, pt1);
            b25.FillPolygon(greenbr, pt2);
            b25.FillPolygon(redbr, pt3);
            b25.FillPolygon(bluebr, pt4);
            piececolor[25, 1] = 4;
            piececolor[25, 2] = 2;
            piececolor[25, 3] = 1;
            piececolor[25, 4] = 3;

            b26.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b26.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b26.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b26.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);
            
            b26.FillPolygon(yellowbr, pt1);
            b26.FillPolygon(redbr, pt2);
            b26.FillPolygon(greenbr, pt3);
            b26.FillPolygon(bluebr, pt4);
            piececolor[26, 1] = 4;
            piececolor[26, 2] = 1;
            piececolor[26, 3] = 2;
            piececolor[26, 4] = 3;

            b27.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b27.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b27.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b27.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b27.FillPolygon(redbr, pt1);
            b27.FillPolygon(yellowbr, pt2);
            b27.FillPolygon(greenbr, pt3);
            b27.FillPolygon(bluebr, pt4);
            piececolor[27, 1] = 1;
            piececolor[27, 2] = 4;
            piececolor[27, 3] = 2;
            piececolor[27, 4] = 3;

            b28.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b28.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b28.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b28.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b28.FillPolygon(redbr, pt1);
            b28.FillPolygon(greenbr, pt2);
            b28.FillPolygon(bluebr, pt3);
            b28.FillPolygon(greenbr, pt4);
            piececolor[28, 1] = 1;
            piececolor[28, 2] = 2;
            piececolor[28, 3] = 3;
            piececolor[28, 4] = 2;

            b29.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b29.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b29.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b29.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b29.FillPolygon(redbr, pt1);
            b29.FillPolygon(greenbr, pt2);
            b29.FillPolygon(bluebr, pt3);
            b29.FillPolygon(redbr, pt4);
            piececolor[29, 1] = 1;
            piececolor[29, 2] = 2;
            piececolor[29, 3] = 3;
            piececolor[29, 4] = 1;

            b30.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b30.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b30.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b30.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b30.FillPolygon(redbr, pt1);
            b30.FillPolygon(redbr, pt2);
            b30.FillPolygon(bluebr, pt3);
            b30.FillPolygon(yellowbr, pt4);
            piececolor[30, 1] = 1;
            piececolor[30, 2] = 1;
            piececolor[30, 3] = 3;
            piececolor[30, 4] = 4;

            b31.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b31.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b31.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b31.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b31.FillPolygon(redbr, pt1);
            b31.FillPolygon(greenbr, pt2);
            b31.FillPolygon(bluebr, pt3);
            b31.FillPolygon(bluebr, pt4);
            piececolor[31, 1] = 1;
            piececolor[31, 2] = 2;
            piececolor[31, 3] = 3;
            piececolor[31, 4] = 3;

            b32.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b32.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b32.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b32.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b32.FillPolygon(greenbr, pt1);
            b32.FillPolygon(greenbr, pt2);
            b32.FillPolygon(bluebr, pt3);
            b32.FillPolygon(yellowbr, pt4);
            piececolor[32, 1] = 2;
            piececolor[32, 2] = 2;
            piececolor[32, 3] = 3;
            piececolor[32, 4] = 4;
           
            b33.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b33.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b33.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b33.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b33.FillPolygon(redbr, pt1);
            b33.FillPolygon(bluebr, pt2);
            b33.FillPolygon(bluebr, pt3);
            b33.FillPolygon(yellowbr, pt4);
            piececolor[33, 1] = 1;
            piececolor[33, 2] = 3;
            piececolor[33, 3] = 3;
            piececolor[33, 4] = 4;

            b34.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b34.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b34.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b34.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b34.FillPolygon(bluebr, pt1);
            b34.FillPolygon(redbr, pt2);
            b34.FillPolygon(redbr, pt3);
            b34.FillPolygon(yellowbr, pt4);
            piececolor[34, 1] = 3;
            piececolor[34, 2] = 1;
            piececolor[34, 3] = 1;
            piececolor[34, 4] = 4;

            b35.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b35.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b35.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b35.DrawLine(new Pen(Color.Black), 1,52, 52, 1);
            
            b35.FillPolygon(redbr, pt1);
            b35.FillPolygon(bluebr, pt2);
            b35.FillPolygon(bluebr, pt3);
            b35.FillPolygon(yellowbr, pt4);
            piececolor[35, 1] = 1;
            piececolor[35, 2] = 3;
            piececolor[35, 3] = 3;
            piececolor[35, 4] = 4;

            b36.DrawRectangle(new Pen(Color.Black), 1, 1, 52, 52);
            b36.DrawRectangle(new Pen(Color.Black), 3, 3, 48, 48);
            b36.DrawLine(new Pen(Color.Black), 1, 1, 52, 52);
            b36.DrawLine(new Pen(Color.Black), 1, 52, 52, 1);

            b36.FillPolygon(redbr, pt1);
            b36.FillPolygon(yellowbr, pt2);
            b36.FillPolygon(yellowbr, pt3);
            b36.FillPolygon(greenbr, pt4);
            piececolor[36, 1] = 1;
            piececolor[36, 2] = 4;
            piececolor[36, 3] = 4;
            piececolor[36, 4] = 2;
        }
        private void Setup()
        {
            int a = 1;
            int b = 1;
            int r = 1;
            
            while (b < 9)
            {
                while (a < 9) // 51,  x stays < 800
                {
                    r = rnd.Next(1, 37);
                    brd[a, b] = r;
                    a = a + 1;
                }
                a = 1;
                b = b + 1;
            }
            r = rnd.Next(1, 6);
            if (r == 1)
            {
                brd[1, 8] = 36; brd[2, 8] = 29; brd[3, 8] = 24; brd[4, 8] = 23;
                brd[5, 8] = 19; brd[6, 8] = 7; brd[7, 8] = 13; brd[8, 8] = 10;
            }
            if (r == 2)
            {
                brd[1, 8] = 35; brd[2, 8] = 7; brd[3, 8] = 19; brd[4, 8] = 10;
                brd[5, 8] = 24; brd[6, 8] = 23; brd[7, 8] = 13; brd[8, 8] = 29;
            } 
            if (r == 3)
            {
                brd[1, 8] = 34; brd[2, 8] = 7; brd[3, 8] = 13; brd[4, 8] = 23;
                brd[5, 8] = 19; brd[6, 8] = 24; brd[7, 8] = 10; brd[8, 8] = 29;
            } 
            if (r == 4)
            {
                brd[1, 8] = 33; brd[2, 8] = 13; brd[3, 8] = 29; brd[4, 8] = 23;
                brd[5, 8] = 19; brd[6, 8] = 24; brd[7, 8] = 7; brd[8, 8] = 10;
            } 
            if (r == 5)
            {
                brd[1, 8] = 31; brd[2, 8] = 7; brd[3, 8] = 24; brd[4, 8] = 13;
                brd[5, 8] = 10; brd[6, 8] = 29; brd[7, 8] = 19; brd[8, 8] = 23;
            }

        }
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(bmp1, 0, 0);
        }
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            //brd[bx, by] = 0;
        }
        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / bsize -3; 
            by = my / bsize ;


           
            UpdateScreen();
        }
        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            int a = 0;
            //brd[bx, by] = bx;


            if (move == 1) // pick up first piece
            {
                
                Move1();
                
                a = 1;
            }
            if (move == 2) if (a == 0) // pick up 2nd piece
                {
                    
                    Move2();
                    MoveDown(); // move pieces down to fill empty squares.
                    MoveLeft();
                }

            UpdateScreen();
        }
        private void MoveDown()
        {
            
            int a = 1;
            int b = 1;
            int d = 1;
            cnt = 0;
            while (d < 10)
            {
                a = 1;
                b = 1;
                while (b < 8)
                {
                    while (a < 9) 
                    {
                        if (brd[a, b] > 0) if (brd[a, b + 1] == 0)
                            {
                                brd[a, b + 1] = brd[a, b];
                                brd[a, b] = 0;

                            }
                        a = a + 1;
                    }
                    b = b + 1;
                    a = 1;
                }
                d = d + 1;
            }


        }
        private void MoveLeft()
        {

            int a = 2;
            int b = 1;
            
                
                    while (a < 9) 
                    {
                        if (brd[a, 8] > 0) if (brd[a-1, 8] == 0)
                            {
                                brd[a-1, 8] = brd[a, 8];
                                brd[a, 8] = 0;
                                brd[a - 1, 7] = brd[a, 7];
                                brd[a, 7] = 0;
                                brd[a - 1, 6] = brd[a, 6];
                                brd[a, 6] = 0;
                                brd[a - 1, 5] = brd[a, 5];
                                brd[a, 5] = 0;
                                brd[a - 1, 4] = brd[a, 4];
                                brd[a, 4] = 0;
                                brd[a - 1, 3] = brd[a, 3];
                                brd[a, 3] = 0;
                                brd[a - 1, 2] = brd[a, 2];
                                brd[a, 2] = 0;
                                brd[a - 1, 1] = brd[a, 1];
                                brd[a, 1] = 0;
                                score = score + 10;
                            }
                        a = a + 1;
                    }
                      

        }
        private void Move1()
        {
            c1 = 0;
            c2 = 0;
            c3 = 0;
            c4 = 0;
            oldx = 0;
            oldy = 0;
            if (bx < 1) return;
            if (by < 1) return;
            if (bx > 8) return;
            if (by > 8) return;
            p1 = brd[bx, by];
            if (p1 == 0) return;
            oldx = bx;
            oldy = by;
            c1 = piececolor[p1, 1]; // right
            c2 = piececolor[p1, 2]; // top
            c3 = piececolor[p1, 3]; // bottom 
            c4 = piececolor[p1, 4]; // left
            Sounds.Play("laser.wav");
            move = 2;

        }
        private void Move2()
        {
            c11 = 0;
            c12 = 0;
            c13 = 0;
            c14 = 0;
            if (bx < 1) return;
            if (by < 1) return;
            if (bx > 8) return;
            if (by > 8) return;
            p2 = brd[bx, by];
            if (p2 == 0) return;
            c11 = piececolor[p2, 1]; // right
            c12 = piececolor[p2, 2]; // top
            c13 = piececolor[p2, 3]; // bottom 
            c14 = piececolor[p2, 4]; // left
            if (c11 == c4) if (oldx - bx == 1) 
            {
                brd[bx, by] = brd[oldx, oldy];
                brd[oldx, oldy] = 0;
                score = score + 1;
            }
            if (c12 == c3) if (by - oldy == 1) 
            {
                brd[bx, by] = brd[oldx, oldy];
                brd[oldx, oldy] = 0;
                score = score + 1;
            }
            if (c13 == c2) if (oldy - by == 1) 
            {
                brd[bx, by] = brd[oldx, oldy];
                brd[oldx, oldy] = 0;
                score = score + 1;
            }
            if (c14 == c1) if (bx - oldx == 1) 
            {
                brd[bx, by] = brd[oldx, oldy];
                brd[oldx, oldy] = 0;
                score = score + 1; 
            } 

            Sounds.Play("SMACK.wav");
            move = 1;
        }
        private void UpdateScreen()
        {

            z.FillRectangle(br2, 0.0F, 0.0F, 800.0F, 600.0F);
            //brd[2, 10] = piece1;
           if(gameover==0) MakeBoard();
           if(gameover==0) UpdateScreen1();
           if (gameover == 1) EndPrint();
           // UpdateScreen2();
           // UpdateScreen3();
           // UpdateScreen4();
           // UpdateScreen5();
            z.DrawString("Score  =", myfont, Brushes.White, 20, 500);
            z.DrawString(score.ToString(), myfont, Brushes.White, 110, 500);
            //z.DrawString(cnt.ToString(), myfont, Brushes.White, 20, 400);
            //z.DrawString(c2.ToString(), myfont, Brushes.White, 20, 420);
            //z.DrawString(c3.ToString(), myfont, Brushes.White, 20, 440);
            //z.DrawString(c4.ToString(), myfont, Brushes.White, 20, 460);
            Instructions();
            Invalidate();
            Update();

        }
        private void UpdateScreen1()
        {

            int x = 1;
            int y = 1;
            int a = 1;
            int b = 1;
            //brd[2, 2] = 1;
            while (b < 11)
            {
                while (a < 11) // 51,  x stays < 800
                {
                  

                    if (brd[a, b] == 1) { z.DrawImage(bm1, x + 224, y + 56); }
                    if (brd[a, b] == 2) { z.DrawImage(bm2, x + 224, y + 56); }
                    if (brd[a, b] == 3) { z.DrawImage(bm3, x + 224, y + 56); }
                    if (brd[a, b] == 4) { z.DrawImage(bm4, x + 224, y + 56); }
                    if (brd[a, b] == 5) { z.DrawImage(bm5, x + 224, y + 56); }
                    if (brd[a, b] == 6) { z.DrawImage(bm6, x + 224, y + 56); }
                    if (brd[a, b] == 7) { z.DrawImage(bm7, x + 224, y + 56); }
                    if (brd[a, b] == 8) { z.DrawImage(bm8, x + 224, y + 56); }
                    if (brd[a, b] == 9) { z.DrawImage(bm9, x + 224, y + 56); }
                    if (brd[a, b] == 10) { z.DrawImage(bm10, x + 224, y + 56); }
                    if (brd[a, b] == 11) { z.DrawImage(bm11, x + 224, y + 56); }
                    if (brd[a, b] == 12) { z.DrawImage(bm12, x + 224, y + 56); }
                    if (brd[a, b] == 13) { z.DrawImage(bm13, x + 224, y + 56); }
                    if (brd[a, b] == 14) { z.DrawImage(bm14, x + 224, y + 56); }
                    if (brd[a, b] == 15) { z.DrawImage(bm15, x + 224, y + 56); }
                    if (brd[a, b] == 16) { z.DrawImage(bm16, x + 224, y + 56); }
                    if (brd[a, b] == 17) { z.DrawImage(bm17, x + 224, y + 56); }
                    if (brd[a, b] == 18) { z.DrawImage(bm18, x + 224, y + 56); }
                    if (brd[a, b] == 19) { z.DrawImage(bm19, x + 224, y + 56); }
                    if (brd[a, b] == 20) { z.DrawImage(bm20, x + 224, y + 56); }
                    if (brd[a, b] == 21) { z.DrawImage(bm21, x + 224, y + 56); }
                    if (brd[a, b] == 22) { z.DrawImage(bm22, x + 224, y + 56); }
                    if (brd[a, b] == 23) { z.DrawImage(bm23, x + 224, y + 56); }
                    if (brd[a, b] == 24) { z.DrawImage(bm24, x + 224, y + 56); }
                    if (brd[a, b] == 25) { z.DrawImage(bm25, x + 224, y + 56); }
                    if (brd[a, b] == 26) { z.DrawImage(bm26, x + 224, y + 56); }
                    if (brd[a, b] == 27) { z.DrawImage(bm27, x + 224, y + 56); }
                    if (brd[a, b] == 28) { z.DrawImage(bm28, x + 224, y + 56); }
                    if (brd[a, b] == 29) { z.DrawImage(bm29, x + 224, y + 56); }
                    if (brd[a, b] == 30) { z.DrawImage(bm30, x + 224, y + 56); }
                    if (brd[a, b] == 31) { z.DrawImage(bm31, x + 224, y + 56); }
                    if (brd[a, b] == 32) { z.DrawImage(bm32, x + 224, y + 56); }
                    if (brd[a, b] == 33) { z.DrawImage(bm33, x + 224, y + 56); }
                    if (brd[a, b] == 34) { z.DrawImage(bm34, x + 224, y + 56); }
                    if (brd[a, b] == 35) { z.DrawImage(bm35, x + 224, y + 56); }
                    if (brd[a, b] == 36) { z.DrawImage(bm36, x + 224, y + 56); }
                    x = x + bsize;
                    a = a + 1;
                  
                }
                b = b + 1;
                a = 1;
                x = 1;
                y = y + bsize;
            }


        }
          private void Instructions()
        {

            z.DrawString(" The object of the game is to", font10, Brushes.White, 0, 100);
            z.DrawString("remove as many squares as  ", font10, Brushes.White, 1, 118);
            z.DrawString("possible. ", font10, Brushes.White, 1, 136);
            z.DrawString(" Click a square and then click a ", font10, Brushes.White, 1, 154);
            z.DrawString("near-by square with a color match. ", font10, Brushes.White, 1, 172);
            z.DrawString(" The 1st square will then take the ", font10, Brushes.White, 1, 190);
            z.DrawString("place of the second square. ", font10, Brushes.White, 1, 208);
            z.DrawString(" Each square has 4 colors and you ", font10, Brushes.White, 1, 226);
            z.DrawString("must match up only the colors that ", font10, Brushes.White, 1, 244);
            z.DrawString("are near each other. ", font10, Brushes.White, 1, 262);
            z.DrawString(" You get extra points for clearing", font10, Brushes.White, 1, 280);
            z.DrawString("out whole columns. ", font10, Brushes.White, 1, 298);
        }
        private void EndPrint()
        {
            z.DrawString("Game Over", myfont, Brushes.White, 10, 10);
            z.FillRectangle(bck,240,90,500,400);
            Print("This program brought to you by:", 250, 110);
            Print("Grace Church of the Nazarene", 250, 130);
            Print("2302 Highland Avenue", 250, 150);
            Print("Columbia, Tennessee 931-388-4788", 250, 170);
            //Print " "
            //Print " "
            //Print " "
            Print("See our website at:", 250, 230);
            Print("www.columbiagrace.org", 250, 250);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 250, 300);
            //Print
            Print("Finally, brethren, whatever things are true,", 250, 340);
            Print("whatever things are noble,whatever things are just,", 250, 360);
            Print("whatever things are pure, whatever things are lovely,", 250, 380);
            Print("whatever things are of good report, if there is any", 250, 400);
            Print("virtue and if there is anything praiseworthy -", 250, 420);
            Print(" meditate on these things.", 250, 440);

        }
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, myfont, Brushes.White, x1, x2);
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
           
            int a = 1;
            int b = 1;
            int c = 0;
            
            while (b < 11)
            {
                while (a < 11) // 51,  x stays < 800
                {
                    if(brd[a,b]>0) c=c+1;
                    a = a + 1;
                }
                b = b + 1;
                a = 1;
            }
            if (c < 1) gameover = 1;
        }
    }
    // @@@@@@@@@@@@@@@@@@@@@@@@ END OF FORM1 @@@@@@@@@@@@@@@@@@@@@@@@@@@@
    public class Sounds
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }
}