

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;


namespace MineField
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }



        // @@@@@@@@@@@@@@@@@@@@@@@@@@@@ Variable section @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        int mx = 0;      // mouse location... dots
        int my = 0;
        
        int bx = 0;      // mouse location board squares 
        int by = 0;
        int dx = 0;
        int dy = 0;
        int sprite1 = 0;
        int r1 = 0;      // random number
        int r2 = 0;
        int start = 0;   // becomes 1 after game starts
        int bcolor = 1;
        int bletter = 1;
        int move = 1;
        int mode = 1;
        int score = 0;
        int gameover = 0;
        
        Random rnd = new Random();
        int[,] brd = new int[20, 20];
        int[,] brd2 = new int[20, 20];
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(0, 0, 40));
        static Size s1 = new Size(160, 500);
        static Bitmap bmp1 = new Bitmap(190, 500);
        static Bitmap bmp2 = new Bitmap(500, 500);
        Graphics z2 = Graphics.FromImage(bmp1);// text area
        Graphics z = Graphics.FromImage(bmp2); // main board
        //@@@@@@@@@@@@@@@@@@@@@@@@ declare bitmaps @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@     
        //PaintEventArgs paint_e;
        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        //Image bm1 = (Image)(new Bitmap(Arrows.Properties.Resources.Down47));
        //Image bm2 = (Image)(new Bitmap(Arrows.Properties.Resources.LD47));
        //Image bm3 = (Image)(new Bitmap(Arrows.Properties.Resources.Left47));
        //Image bm4 = (Image)(new Bitmap(Arrows.Properties.Resources.LU47));
        //Image bm5 = (Image)(new Bitmap(Arrows.Properties.Resources.RD47));
        //Image bm6 = (Image)(new Bitmap(Arrows.Properties.Resources.Right47));
        //Image bm7 = (Image)(new Bitmap(Arrows.Properties.Resources.RU47));
        //Image bm8 = (Image)(new Bitmap(Arrows.Properties.Resources.Up47));

        static Bitmap bm1 = new Bitmap(47, 47);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(47, 47);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(47, 47);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(47, 47);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(47, 47);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(47, 47);
        Graphics b6 = Graphics.FromImage(bm6);
        static Bitmap bm7 = new Bitmap(47, 47);
        Graphics b7 = Graphics.FromImage(bm7);
        static Bitmap bm8 = new Bitmap(47,47 );
        Graphics b8 = Graphics.FromImage(bm8);
        //static Bitmap bm9 = new Bitmap(47,47 );
        //Graphics b9 = Graphics.FromImage(bm9);
        //static Bitmap bm10 = new Bitmap(47,47 );
        //Graphics b10 = Graphics.FromImage(bm10);
        //static Bitmap bm11 = new Bitmap(47,47 );
        //Graphics b11 = Graphics.FromImage(bm11);
        //static Bitmap bm12 = new Bitmap(47, 47);
        //Graphics b12 = Graphics.FromImage(bm12);

        // @@@@@@@@@@@@@@@@@@@@@@@@@@@ Draw Screen @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    


        public void Draw(Graphics g)
        {

            
            //z2.FillRectangle(br1, 0.0F, 0.0F, 176.0F, 500.0F); //text
            //z.FillRectangle(br2, 0.0F, 0.0F, 500.0F, 500.0F);  // Board
            //if (gameover < 1) Update();
            //if (gameover < 1) DrawFrame();
            //Instructions();
            //z2.DrawString(mx.ToString(),myfont, Brushes.White, 10, 400);
            //z2.DrawString(my.ToString(), myfont, Brushes.White, 10, 420);
            //z2.DrawString(bx.ToString(), myfont, Brushes.White, 10, 440);
            //z2.DrawString(by.ToString(), myfont, Brushes.White, 10, 460);

            //z2.DrawString("Score  =", myfont, Brushes.White, 10, 40);
            //z2.DrawString(score.ToString(), myfont, Brushes.White, 100, 40);
            if (gameover > 0) EndPrint();

            if (gameover < 1) Update();
            if (gameover < 1) DrawFrame();
            g.DrawImage(bmp1, 5, 50); // text

            g.DrawLine(new Pen(Color.Blue), 178, 18, 681, 18); // draw lines around board
            g.DrawLine(new Pen(Color.Blue), 178, 521, 681, 521); // bottom
            g.DrawLine(new Pen(Color.Blue), 178, 18, 178, 521); // left
            g.DrawLine(new Pen(Color.Blue), 681, 18, 681, 521); //right

            g.DrawImage(bmp2, 180, 20);// board
             //if (gameover < 1) Update();
             //if (gameover < 1) DrawFrame();

        }

        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Instructions()
        {

            z2.DrawString("Click on a block to remove ", font10, Brushes.White, 0, 100);
            z2.DrawString("from the board. Click on an", font10, Brushes.White, 0, 118);
            z2.DrawString("empty square to put it back.", font10, Brushes.White, 0, 136);
            z2.DrawString("There must be a clear path", font10, Brushes.White, 0, 154);
            z2.DrawString("between the two points. You", font10, Brushes.White, 0, 172);
            z2.DrawString("score points when you get 4", font10, Brushes.White, 0, 190);
            z2.DrawString("of the same blocks in a row ", font10, Brushes.White, 0, 208);
            z2.DrawString("and they are removed from ", font10, Brushes.White, 0, 226);
            z2.DrawString("the board. ", font10, Brushes.White, 0, 244);
            z2.DrawString(" ", font10, Brushes.White, 0, 262);
            z2.DrawString(" ", font10, Brushes.White, 0, 280);
        }

        private void EndPrint()
        {
            z2.DrawString("Game Over", myfont, Brushes.White, 10, 10);
            Print("This program brought to you by:", 10, 10);
            Print("Grace Church of the Nazarene", 10, 30);
            Print("2302 Highland Avenue", 10, 50);
            Print("Columbia, Tennessee 931-388-4788", 10, 70);
            //Print " "
            //Print " "
            //Print " "
            Print("See our website at:", 10, 130);
            Print("www.columbiagrace.org", 10, 150);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 10, 200);
            //Print
            Print("Finally, brethren, whatever things are true,", 10, 240);
            Print("whatever things are noble,whatever things are just,", 10, 260);
            Print("whatever things are pure, whatever things are lovely,", 10, 280);
            Print("whatever things are of good report, if there is any", 10, 300);
            Print("virtue and if there is anything praiseworthy -", 10, 320);
            Print(" meditate on these things.", 10, 340);

        }

        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, myfont, Brushes.White, x1, x2);
        }
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void UpdateBoard()
        {
            int a = 2;
            int b = 2;
            int x = 50;
            int y = 50;
            z.FillRectangle(br2, 0.0F, 0.0F, 500.0F, 500.0F);  //  Eraise Board

            while (b < 11)
            {
                while (a < 11)
                {

                    if (brd[a, b] == 1) { z.DrawImage(bm1, x + 1, y + 1); } // sprites
                    if (brd[a, b] == 2) { z.DrawImage(bm2, x + 1, y + 1); }
                    if (brd[a, b] == 3) { z.DrawImage(bm3, x + 1, y + 1); }
                    if (brd[a, b] == 4) { z.DrawImage(bm4, x + 1, y + 1); }
                    if (brd[a, b] == 5) { z.DrawImage(bm5, x + 1, y + 1); }
                    if (brd[a, b] == 6) { z.DrawImage(bm6, x + 1, y + 1); }
                    if (brd[a, b] == 7) { z.DrawImage(bm7, x + 1, y + 1); }
                    if (brd[a, b] == 8) { z.DrawImage(bm8, x + 1, y + 1); }
                    
                    x = x + 50;
                    a = a + 1;
                }
                b = b + 1;
                a = 1;
                x = 50;
                y = y + 50;


            }
            x = 100;  // draw extra piece
            y = 20;
            //z.DrawImage(bm1, x + 100, y + 1);

            if (sprite1 == 1) { z.DrawImage(bm1, x + 1, y + 1); } // colors
            if (sprite1 == 2) { z.DrawImage(bm2, x + 1, y + 1); }
            if (sprite1 == 3) { z.DrawImage(bm3, x + 1, y + 1); }
            if (sprite1 == 4) { z.DrawImage(bm4, x + 1, y + 1); }
            if (sprite1 == 5) { z.DrawImage(bm5, x + 1, y + 1); }
            if (sprite1 == 6) { z.DrawImage(bm6, x + 1, y + 1); }
            if (sprite1 == 7) { z.DrawImage(bm7, x + 1, y + 1); }
            if (sprite1 == 8) { z.DrawImage(bm8, x + 1, y + 1); }
            

        }

        private void DrawFrame()
        {
            int a = 0;
            while (a < 9)
            {              // vertical lines

                z.DrawLine(new Pen(Color.Aquamarine), (a * 50)+50, 50, a * 50+50, 450);
                a = a + 1;
            }
            //z.DrawLine(new Pen(Color.Aquamarine), 499, 0, 499, 499);
            //z.DrawLine(new Pen(Color.Aquamarine), 0, 499, 499, 499);
            a = 0;
            while (a < 9)
            {              // Horizontal lines

                z.DrawLine(new Pen(Color.Aquamarine), 50, 50 * a+50, 450, 50 * a+50);
                a = a + 1;
            }
            z.DrawLine(new Pen(Color.Blue), 2, 2, 2, 498); // left
            z.DrawLine(new Pen(Color.Blue), 2, 2, 497, 2); // top
            z.DrawLine(new Pen(Color.Blue), 2, 498, 497, 498); // bottom
            z.DrawLine(new Pen(Color.Blue), 497, 498, 497, 2); // right

            z.DrawLine(new Pen(Color.Blue), 48, 48, 48, 452); // left
            z.DrawLine(new Pen(Color.Blue), 48, 48, 452, 48); // top
            z.DrawLine(new Pen(Color.Blue), 48, 452, 452, 452); // bottom
            z.DrawLine(new Pen(Color.Blue), 452, 48, 452, 452); // right

            z.DrawLine(new Pen(Color.Red), 46, 46, 46, 454); // left
            z.DrawLine(new Pen(Color.Red), 46, 46, 454, 46); // top
            z.DrawLine(new Pen(Color.Red), 46, 454, 454, 454); // bottom
            z.DrawLine(new Pen(Color.Red), 454, 46, 454, 454); // right

        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;
            bx = mx - 230;
            bx = bx / 50;

            by = (my - 20) / 50 - 1;
            dx = bx + 1;
            dy = by + 1;

            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);

            UpdateText();
            Invalidate();
            Update();


        }
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (start == 0) Start();
            //Draw(e.Graphics);

            if (gameover > 0) EndPrint();

            //if (gameover < 1) Update();
            //if (gameover < 1) DrawFrame();
            e.Graphics.DrawImage(bmp1, 5, 50); // text

            e.Graphics.DrawLine(new Pen(Color.Blue), 178, 18, 681, 18); // draw lines around board
            e.Graphics.DrawLine(new Pen(Color.Blue), 178, 521, 681, 521); // bottom
            e.Graphics.DrawLine(new Pen(Color.Blue), 178, 18, 178, 521); // left
            e.Graphics.DrawLine(new Pen(Color.Blue), 681, 18, 681, 521); //right

            e.Graphics.DrawImage(bmp2, 180, 20);// board
            
        }
        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            
            
            if (gameover < 1)
            {
               
                Sounds.Play("beep1.wav");
                brd[dx, dy] = 1;
                    //MakeMove();
                    UpdateText();
                    UpdateBoard();
                    DrawFrame();
                    
                    if (move == 1)
                    {
                    move = 2;

                    }
                if (move == 2)
                {
                    
                    move = 3;
                }
                if (move == 3)
                {
                    
                    move = 4;
                }

                if (move == 4)
                {
                    points();
                    move = 5;
                }
                if (move > 4) move = 1;
               
                Invalidate();
                Update();
            }
        }

        private void MakeMove()
        {
            int a = 2;
            int b = 2;
            int dx = bx+2;
            int dy = by+2;
            if (mode == 1)
            {
                if (brd[dx, dy] > 0) a = brd[dx , dy ];
                if (sprite1 > 0) b = sprite1;
                sprite1 = a;
                brd[dx, dy] = b;
            }


        }


        private void points()
        {
            int a = 0;
           

        }


        //@@@@@@@@@@@@@@@@@@@@@@ Do one time at start of program @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Start()
        {
            int x = 0;
            int y = 0;
            brd[5, 5] = 1;
            b1.FillRectangle(Brushes.Red, 2.0F, 2.0F, 46.0F, 46.0F);
           // sprite1 = rnd.Next(1, 7);
            

           // for (int i = 1; i < 16; i++)
           // {

           //     x = rnd.Next(3, 9);
           //     y = rnd.Next(3, 9);

           //     r1 = rnd.Next(1, 9);
          //      brd[x, y] = r1; // sprite numbers
               
          //  }

            start = 1;
            
            UpdateText();
            UpdateBoard();
            DrawFrame();
        }

        private void UpdateText()
        {
            z2.FillRectangle(br1, 0.0F, 0.0F, 176.0F, 500.0F); //text
            
            //if (gameover < 1) Update();
            //if (gameover < 1) DrawFrame();
            Instructions();
            z2.DrawString(sprite1.ToString(), myfont, Brushes.White, 10, 380);
            z2.DrawString(mx.ToString(), myfont, Brushes.White, 10, 400);
            z2.DrawString(my.ToString(), myfont, Brushes.White, 10, 420);
            z2.DrawString(dx.ToString(), myfont, Brushes.White, 10, 440);
            z2.DrawString(dy.ToString(), myfont, Brushes.White, 10, 460);

            z2.DrawString("Score  =", myfont, Brushes.White, 10, 40);
            z2.DrawString(score.ToString(), myfont, Brushes.White, 100, 40); 
        }



        private void Gameover()
        {
            int a = 0;
            for (int y = 1; y < 11; y++)
            {
                for (int x = 1; x < 11; x++)
                {
                    if (brd[x, y] > 0)
                    {
                        a = a + 1;
                    }
                }
            }
            //if (a > 95) gameover = 1;
        }

       
     


        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  

    }
    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    public class Sounds
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }



}