using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;

namespace BoxIt
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        int mx = 0;    // mouse horizontal pixel position
        int my = 0;    // mouse vertical position
        int bx = 0;   // column number of mouse
        int by = 0;   // row number of mouse
        int dx = 0;   // old coordinates
        int dy = 0;
       
        int bsize = 48; // square size
        int cnt = 0;
        int move = 1;
        int score = 0;
        int rndcnt = 1;
        int computermove = 1;
        int piece = 0;
        int gameover = 0;

        Random rnd = new Random();
        int[] rnd6 = { 1,1,2,3,4,5,6, 3,5,2,1,4,6, 4,5,6,3,2,1, 1,2,6,3,5,4, 4,5,3,6,2,1 /
     6,5,4,3,2,1, 5,3,1,6,4,2, 1,2,3,4,5,6, 3,5,2,1,4,6, 4,5,6,3,2,1, 1,2,6,3,5,4 /
     1,2,6,3,5,4, 1,6,2,5,3,4, 6,4,3,2,5,1, 5,4,3,2,1,6, 1,5,4,6,3,2, 4,3,6,1,2,5 };

        int[,] brd = new int[20, 20];  // Array for holding piece information 
        int[,] brd2 = new int[20, 20]; // layer 2
        int[,] brd3 = new int[20, 20]; // layer 3
        
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(200, 200, 200));
        Brush br3 = new SolidBrush(Color.FromArgb(0, 0, 250));
        Brush br4 = new SolidBrush(Color.LightSlateGray);
        Brush br5 = new SolidBrush(Color.DarkSlateGray);
        Brush redbr = new SolidBrush(Color.Red);
        Brush blackbr = new SolidBrush(Color.Black);

        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        Pen bluepen = new Pen(Color.Blue);
        Pen whitepen = new Pen(Color.White);
        Pen redpen = new Pen(Color.Red);
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@ bitmap section @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        static Bitmap bmp1 = new Bitmap(800, 600);
        Graphics z = Graphics.FromImage(bmp1);

        static Bitmap bm1 = new Bitmap(47, 47);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(47, 47);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(47, 47);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(47, 47);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(47, 47);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(47, 47);
        Graphics b6 = Graphics.FromImage(bm6);

        static Bitmap bm11 = new Bitmap(47, 47);
        Graphics b11 = Graphics.FromImage(bm11);
        static Bitmap bm12 = new Bitmap(47, 47);
        Graphics b12 = Graphics.FromImage(bm12);
        static Bitmap bm13 = new Bitmap(47, 47);
        Graphics b13 = Graphics.FromImage(bm13);
        static Bitmap bm14 = new Bitmap(47, 47);
        Graphics b14 = Graphics.FromImage(bm14);
        static Bitmap bm15 = new Bitmap(47, 47);
        Graphics b15 = Graphics.FromImage(bm15);
        static Bitmap bm16 = new Bitmap(47, 47);
        Graphics b16 = Graphics.FromImage(bm16);


        Image sp1 = (Image)(new Bitmap(BoxIt.Properties.Resources.red));
        Image sp2 = (Image)(new Bitmap(BoxIt.Properties.Resources.blue));
        Image sp3 = (Image)(new Bitmap(BoxIt.Properties.Resources.green));
        Image sp4 = (Image)(new Bitmap(BoxIt.Properties.Resources.cyan));
        Image sp5 = (Image)(new Bitmap(BoxIt.Properties.Resources.purple));
        Image sp6 = (Image)(new Bitmap(BoxIt.Properties.Resources.yellow));

        private void Form1_Load(object sender, EventArgs e)
        {
            //r1 = rnd.Next(1, 7);
            //r2 = rnd.Next(1, 7);
            rndcnt = rnd.Next(1, 20); // initialize random pointer
            Setup();
            MakeSprites();
            UpdateScreen();

        }

        private void Setup()
        {
            int a = 1;
            int b = 1;
           // a = Rand6();  // get random numbers 1-6
            rndcnt = rnd.Next(1, 50); // initialize random pointer
            while (b < 11)
            {
                while (a < 11) // 51,  x stays < 800
                {
                    brd[a, b] = Rand6(); // get numbers 1-6
                    a = a + 1;
                 
                }
                b = b + 1;
                a = 1;
            }
        }
        private int Rand6()
        {
            int a = 1;
            rndcnt = rndcnt + 1;
            if (rndcnt > 99) rndcnt = 1;
            a = rnd6[rndcnt];
            if (a < 1) a = 3;
            return a;
        }

        private void MakeBoard() // size48 10x
        {
            int x = 0;
            int y = 0;
            int a = 0;
            z.FillRectangle(br5, 228, 36, 504, 504);
            z.FillRectangle(blackbr, 236, 44, 489, 489);
            z.FillRectangle(br4, 238, 46, 484, 484);
            
            while (a < 11)
            {
                z.DrawLine(whitepen, 240+x, 48, 240+x, 527); // vertical
                a = a + 1;
                x = x + 48;
            }
            a = 0;
            while (a < 11)
            {
                z.DrawLine(whitepen, 240 , 48+y, 719, 48+y); // vertical
                a = a + 1;
                y = y + 48;
            }
        }
        private void DrawFrame() // size48 10x
        {
            int x = 0;
            int y = 0;
            int a = 0;
           

            while (a < 11)
            {
                z.DrawLine(whitepen, 240 + x, 48, 240 + x, 527); // vertical
                a = a + 1;
                x = x + 48;
            }
            a = 0;
            while (a < 11)
            {
                z.DrawLine(whitepen, 240, 48 + y, 719, 48 + y); // vertical
                a = a + 1;
                y = y + 48;
            }
        }
        private void MakeSprites()
        {
            b1.FillRectangle(Brushes.Red, 1.0F, 1.0F, 16.0F, 16.0F);
            b2.FillRectangle(Brushes.Blue, 1.0F, 1.0F, 16.0F, 16.0F);
            b3.FillRectangle(Brushes.Green, 1.0F, 1.0F, 16.0F, 16.0F);
            b4.FillRectangle(Brushes.Cyan, 1.0F, 1.0F, 16.0F, 16.0F);
            b5.FillRectangle(Brushes.Purple, 1.0F, 1.0F, 16.0F, 16.0F);
            b6.FillRectangle(Brushes.Yellow, 1.0F, 1.0F, 16.0F, 16.0F);

            b11.FillRectangle(Brushes.Red, 0.0F, 0.0F, 47.0F, 47.0F);
            b12.FillRectangle(Brushes.Blue, 0.0F, 0.0F, 47.0F, 47.0F);
            b13.FillRectangle(Brushes.Green, 0.0F, 0.0F, 47.0F, 47.0F);
            b14.FillRectangle(Brushes.Cyan, 0.0F, 0.0F, 47.0F, 47.0F);
            b15.FillRectangle(Brushes.Purple, 0.0F, 0.0F, 47.0F, 47.0F);
            b16.FillRectangle(Brushes.Yellow, 0, 0, 47, 47);

        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(bmp1, 0, 0);
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {

        }
        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / bsize - 4 ;
            by = my / bsize ;


           
            //UpdateScreen();
        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            int a = 0;
            //brd[bx, by] = bx;

            if (computermove == 0)
            {
                if (move == 1) // pick up first piece
                {
                    Sounds.Play("laser.wav");
                    Move1();
                    a = 1;
                }
                if (move == 2) if (a == 0) // pick up 2nd piece
                    {
                        
                        Move2();
                    }

                UpdateScreen();
            }
        }

     
        private void Move1()
        {

            piece = brd2[bx, by];
            if (piece > 0)if(brd3[bx,by]==0)
            {
                dx = bx;
                dy = by;
                brd2[bx, by] = 0;
                move = 2;
            }

        }

        private void Move2()
        {
            int a = 0;
            int b = 0;
            a = CheckPath();
            if(a==0)
            {
              Sounds.Play("SMACK.wav");
              brd2[bx, by] = piece;
              if (brd[bx, by] == piece) brd3[bx, by] = piece;
              
              move = 1;
              if (brd[bx, by] == piece) score = score + 1;
              piece = 0;
              computermove = 1;
            }
            if (a == 1)
            {
                Sounds.Play("SMACK.wav");
                move = 1;
                brd2[dx, dy] = piece;
                piece = 0;
            }

        }
        private int CheckPath()
        {
            int a = 1;
            int b = 1;
            int z = 1;
            if (bx == dx) z = 0;
            if (by == dy) z = 0;
            if (brd2[bx, by] > 0) z = 1; // 1=no move
           

            return z;
        }
      

        private void UpdateScreen()
        {

            z.FillRectangle(br2, 0, 0, 800, 600);
            //brd[2, 10] = piece1;
            if (gameover == 0)
            {
                MakeBoard();
                UpdateScreen1();
                UpdateScreen2();
                UpdateScreen3();
                // UpdateScreen4();
                // UpdateScreen5();
                DrawFrame();
            }
            else EndPrint();
            z.DrawString("Score  =", myfont, Brushes.Black, 20, 500);
            z.DrawString(score.ToString(), myfont, Brushes.Black, 110, 500);
            z.DrawString(computermove.ToString(), myfont, Brushes.Black, 20, 460);
            if(gameover==1) z.DrawString("GAMEOVER", myfont, Brushes.Black, 50, 50);
            //z.DrawString(mx.ToString(), myfont, Brushes.Black, 50, 460);
            //z.DrawString(my.ToString(), myfont, Brushes.Black, 50, 480);
            Instructions();
            Invalidate();
            Update();

        }


        private void UpdateScreen1()
        {

            int x = 1;
            int y = 1;
            int a = 1;
            int b = 1;

            while (b < 11)
            {
                while (a < 11) // 51,  x stays < 800
                {
                  

                    if (brd[a, b] == 1) { z.DrawImage(bm1, x+240, y+48); } // small squares
                    if (brd[a, b] == 2) { z.DrawImage(bm2, x+240, y+48); }
                    if (brd[a, b] == 3) { z.DrawImage(bm3, x+240, y+48); }
                    if (brd[a, b] == 4) { z.DrawImage(bm4, x+240, y+48); }
                    if (brd[a, b] == 5) { z.DrawImage(bm5, x+240, y+48); }
                    if (brd[a, b] == 6) { z.DrawImage(bm6, x+240, y+48); }
                    x = x + bsize;
                    a = a + 1;
                  
                }
                b = b + 1;
                a = 1;
                x = 1;
                y = y + bsize;
            }


        }
        private void UpdateScreen2()
        {

            int x = 1;
            int y = 1;
            int a = 1;
            int b = 1;
            
            while (b < 11)
            {
                while (a < 11) // 51,  x stays < 800
                {


                    if (brd2[a, b] == 1) { z.DrawImage(sp1, x + 239, y + 48); }// marbles
                    if (brd2[a, b] == 2) { z.DrawImage(sp2, x + 239, y + 48); }
                    if (brd2[a, b] == 3) { z.DrawImage(sp3, x + 239, y + 48); }
                    if (brd2[a, b] == 4) { z.DrawImage(sp4, x + 239, y + 48); }
                    if (brd2[a, b] == 5) { z.DrawImage(sp5, x + 239, y + 48); }
                    if (brd2[a, b] == 6) { z.DrawImage(sp6, x + 239, y + 48); }
                    x = x + bsize;
                    a = a + 1;

                }
                b = b + 1;
                a = 1;
                x = 1;
                y = y + bsize;
            }


        }

        private void UpdateScreen3()
        {

            int x = 1;
            int y = 1;
            int a = 1;
            int b = 1;

            while (b < 11)
            {
                while (a < 11) // 51,  x stays < 800
                {


                    if (brd3[a, b] == 1) { z.DrawImage(bm11, x + 240, y + 48); }// large squares
                    if (brd3[a, b] == 2) { z.DrawImage(bm12, x + 240, y + 48); }
                    if (brd3[a, b] == 3) { z.DrawImage(bm13, x + 240, y + 48); }
                    if (brd3[a, b] == 4) { z.DrawImage(bm14, x + 240, y + 48); }
                    if (brd3[a, b] == 5) { z.DrawImage(bm15, x + 240, y + 48); }
                    if (brd3[a, b] == 6) { z.DrawImage(bm16, x + 240, y + 48); }
                    x = x + bsize;
                    a = a + 1;

                }
                b = b + 1;
                a = 1;
                x = 1;
                y = y + bsize;
            }
        }
        private void Instructions()
        {

            z.DrawString(" Click on a marble with the mouse ", font10, Brushes.Black, 0, 100);
            z.DrawString("to pick it up and click on an open ", font10, Brushes.Black, 0, 118);
            z.DrawString("space to place it. ", font10, Brushes.Black, 0, 136);
            z.DrawString(" Moves need to be made in a vertical ", font10, Brushes.Black, 0, 154);
            z.DrawString("or horizontal direction. ", font10, Brushes.Black, 0, 172);
            z.DrawString(" Match the color of the marbles with ", font10, Brushes.Black, 0, 190);
            z.DrawString("the small squares to make points. ", font10, Brushes.Black, 0, 208);
            z.DrawString(" ", font10, Brushes.Black, 0, 226);
            z.DrawString(" ", font10, Brushes.Black, 0, 244);
            z.DrawString(" ", font10, Brushes.Black, 0, 262);
            z.DrawString(" ", font10, Brushes.Black, 0, 280);
        }
        private void EndPrint()
        {

            Print("This program brought to you by:", 300, 10);
            Print("Grace Church of the Nazarene", 300, 30);
            Print("2302 Highland Avenue", 300, 50);
            Print("Columbia, Tennessee 931-388-4788", 300, 70);
            //Print " "
            //Print " "
            //Print " "
            Print("See our website at:", 300, 130);
            Print("www.columbiagrace.org", 300, 150);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 300, 200);
            //Print
            Print("Finally, brethren, whatever things are true,", 300, 240);
            Print("whatever things are noble,whatever things are just,", 300, 260);
            Print("whatever things are pure, whatever things are lovely,", 300, 280);
            Print("whatever things are of good report, if there is any", 300, 300);
            Print("virtue and if there is anything praiseworthy -", 300, 320);
            Print(" meditate on these things.", 300, 340);

        }
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, myfont, Brushes.Black, x1, x2);
        }



        private void timer1_Tick(object sender, EventArgs e)
        {
            int a = 0;
            int b = 0;
            int x = 1;
            int y = 1;
            if (computermove == 1)
            {
                a = Rand6();
                x = rnd.Next(1, 11);
                y = rnd.Next(1, 11);
                if (brd2[x, y] == 0) { brd2[x, y] = a; b = 1; }
               if (brd2[x, y] > 0)
               {
                   if (b==0) if (brd2[1, y] == 0) { brd2[1, y] = a; b = 1; }
                   if (b==0) if (brd2[2, y] == 0) { brd2[2, y] = a; b = 1; }
                   if (b==0) if (brd2[3, y] == 0) { brd2[3, y] = a; b = 1; }
                   if (b==0) if (brd2[4, y] == 0) { brd2[4, y] = a; b = 1; }
                   if (b==0) if (brd2[5, y] == 0) { brd2[5, y] = a; b = 1; }
                   if (b==0) if (brd2[6, y] == 0) { brd2[6, y] = a; b = 1; }
                   if (b==0) if (brd2[7, y] == 0) { brd2[7, y] = a; b = 1; }
                   if (b==0) if (brd2[8, y] == 0) { brd2[8, y] = a; b = 1; }
                   if (b==0) if (brd2[9, y] == 0) { brd2[9, y] = a; b = 1; }
                   if (b==0) if (brd2[10, y] == 0) { brd2[10, y] = a; b = 1; }
               }
               
            }
            if (b == 1) { computermove = 0; cnt = cnt + 1; }
            if (cnt > 99) gameover = 1;
            UpdateScreen();
        }

    }
    // @@@@@@@@@@@@@@@@@@@@@@@@ END OF FORM1 @@@@@@@@@@@@@@@@@@@@@@@@@@@@
    public class Sounds
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }
}