using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;

namespace BoxIt
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        int mx = 0;    // mouse horizontal pixel position
        int my = 0;    // mouse vertical position
        int bx = 0;   // column number of mouse
        int by = 0;   // row number of mouse

        int mx2 = 0;    // mouse horizontal pixel position on level 2
        int my2 = 0;    // mouse vertical position
        int bx2 = 0;   // column number of mouse
        int by2 = 0;   // row number of mouse
        int bsize = 48; // square size
        int cnt = 0;  // counters
        int cnt2 = 0;
        int cnt3 = 0;
        int cnt4 = 0;
        int r1 = 1;  // random numbers or holders of array data
        int r2 = 2;
        int r3 = 3;
        int r4 = 4;
        int r5 = 1;
        int move = 1;
        int score = 0;
        Random rnd = new Random();
        int[,] brd = new int[60, 60];  // Array for holding piece information 
        int[,] brd2 = new int[60, 60]; // layer 2
        int[,] brd3 = new int[60, 60]; // layer 3
        int[,] brd4 = new int[60, 60]; // layer 4
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(20, 20, 50));
        Brush br3 = new SolidBrush(Color.FromArgb(0, 0, 250));
        Brush br4 = new SolidBrush(Color.LightSlateGray);
        Brush br5 = new SolidBrush(Color.DarkSlateGray);
        Brush redbr = new SolidBrush(Color.Red);

        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        Pen bluepen = new Pen(Color.Blue);
        Pen whitepen = new Pen(Color.White);
        Pen redpen = new Pen(Color.Red);
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@ bitmap section @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        static Bitmap bmp1 = new Bitmap(800, 600);
        Graphics z = Graphics.FromImage(bmp1);


        private void Form1_Load(object sender, EventArgs e)
        {
            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);
            MakeSprites();
            UpdateScreen();

        }

        private void MakeBoard() // size48 10x
        {
            int x = 0;
            int y = 0;
            int a = 0;
            z.FillRectangle(br5, 228, 36, 504, 504);
            z.FillRectangle(redbr, 236, 44, 489, 489);
            z.FillRectangle(br4, 238, 46, 484, 484);
            
            while (a < 11)
            {
                z.DrawLine(whitepen, 240+x, 48, 240+x, 527); // vertical
                a = a + 1;
                x = x + 48;
            }
            a = 0;
            while (a < 11)
            {
                z.DrawLine(whitepen, 240 , 48+y, 719, 48+y); // vertical
                a = a + 1;
                y = y + 48;
            }
        }

        private void MakeSprites()
        {
            //throw new Exception("The method or operation is not implemented.");
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(bmp1, 0, 0);
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {

        }
        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / bsize + 1;
            by = my / bsize + 1;


           
            UpdateScreen();
        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            int a = 0;
            //brd[bx, by] = bx;


            if (move == 1) // pick up first piece
            {
                Sounds.Play("laser.wav");
                Move1();
                a = 1;
            }
            if (move == 2) if (a == 0) // pick up 2nd piece
                {
                    Sounds.Play("SMACK.wav");
                    Move2();
                }

            UpdateScreen();
        }

     
        private void Move1()
        {
            move = 2;

        }

        private void Move2()
        {
            move = 1;
        }



        private void UpdateScreen()
        {

            z.FillRectangle(br2, 0.0F, 0.0F, 800.0F, 600.0F);
            //brd[2, 10] = piece1;
            UpdateScreen1();
           // UpdateScreen2();
           // UpdateScreen3();
           // UpdateScreen4();
           // UpdateScreen5();
            z.DrawString("Score  =", myfont, Brushes.White, 20, 500);
            z.DrawString(score.ToString(), myfont, Brushes.White, 110, 500);
            z.DrawString(bx.ToString(), myfont, Brushes.White, 20, 460);
            z.DrawString(by.ToString(), myfont, Brushes.White, 20, 480);
            z.DrawString(mx.ToString(), myfont, Brushes.White, 50, 460);
            z.DrawString(my.ToString(), myfont, Brushes.White, 50, 480);
            MakeBoard();
            Invalidate();
            Update();

        }


        private void UpdateScreen1()
        {

            int x = 1;
            int y = 1;
            int a = 1;
            int b = 1;

            while (b < 11)
            {
                while (a < 11) // 51,  x stays < 800
                {
                  

                  //  if (brd[a, b] == 1) { z.DrawImage(sp1, x, y); }
                  //  if (brd[a, b] == 2) { z.DrawImage(sp2, x, y); }
                   // if (brd[a, b] == 3) { z.DrawImage(sp3, x, y); }
                  //  if (brd[a, b] == 4) { z.DrawImage(sp4, x, y); }
                  //  if (brd[a, b] == 5) { z.DrawImage(sp5, x, y); }
                  //  if (brd[a, b] == 6) { z.DrawImage(sp6, x, y); }
                   // if (brd[a, b] == 7) { z.DrawImage(sp7, x, y); }
                   // if (brd[a, b] == 8) { z.DrawImage(sp8, x, y); }
                  //  if (brd[a, b] == 9) { z.DrawImage(sp9, x, y); }
                   // if (brd[a, b] == 10) { z.DrawImage(sp10, x, y); }
                   // if (brd[a, b] == 11) { z.DrawImage(sp11, x, y); }
                   // if (brd[a, b] == 12) { z.DrawImage(sp12, x, y); }
                   // if (brd[a, b] == 13) { z.DrawImage(sp13, x, y); }
                   // if (brd[a, b] == 14) { z.DrawImage(sp14, x, y); }
                   // if (brd[a, b] == 15) { z.DrawImage(sp15, x, y); }
                   // if (brd[a, b] == 16) { z.DrawImage(sp16, x, y); }
                   // if (brd[a, b] == 17) { z.DrawImage(sp17, x, y); }
                   // if (brd[a, b] == 18) { z.DrawImage(sp18, x, y); }
                   // if (brd[a, b] == 19) { z.DrawImage(sp19, x, y); }
                   // if (brd[a, b] == 20) { z.DrawImage(sp20, x, y); }
                   // if (brd[a, b] == 21) { z.DrawImage(sp21, x, y); }
                   // if (brd[a, b] == 22) { z.DrawImage(sp22, x, y); }
                   // if (brd[a, b] == 23) { z.DrawImage(sp23, x, y); }
                    //if (brd[a, b] == 24) { z.DrawImage(sp24, x, y); }
                   // if (brd[a, b] == 25) { z.DrawImage(sp25, x, y); }
                    //if (brd[a, b] == 26) { z.DrawImage(sp26, x, y); }
                   // if (brd[a, b] == 27) { z.DrawImage(sp27, x, y); }
                   // if (brd[a, b] == 28) { z.DrawImage(sp28, x, y); }
                   // if (brd[a, b] == 29) { z.DrawImage(sp29, x, y); }
                   // if (brd[a, b] == 30) { z.DrawImage(sp30, x, y); }
                   // if (brd[a, b] == 31) { z.DrawImage(sp31, x, y); }
                    //if (brd[a, b] == 32) { z.DrawImage(sp32, x, y); }
                    //if (brd[a, b] == 33) { z.DrawImage(sp33, x, y); }
                   // if (brd[a, b] == 34) { z.DrawImage(sp34, x, y); }
                   // if (brd[a, b] == 35) { z.DrawImage(sp35, x, y); }
                   // if (brd[a, b] == 36) { z.DrawImage(sp36, x, y); }
                    x = x + bsize;
                    a = a + 1;
                  
                }
                b = b + 1;
                a = 1;
                x = 1;
                y = y + bsize;
            }


        }
    }
    // @@@@@@@@@@@@@@@@@@@@@@@@ END OF FORM1 @@@@@@@@@@@@@@@@@@@@@@@@@@@@
    public class Sounds
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }
}