
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;



namespace Template1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        int mx = 0;
        int my = 0;
        int bx = 0;
        int by = 0;
        
        int option = 32;
        int cnt = 0;
        int cnt2 = 0;
        int cnt3 = 0;
        int cnt4 = 0;
        int r1 = 1;
        int r2 = 2;
        int r3 = 3;
        int r4 = 4;
        int score = 0;
        int gameover = 0;
        int start = 0;   

        Random rnd = new Random();
        int[,] brd = new int[60, 60];
        int[,] brd2 = new int[60, 60];
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(0, 0, 40));
        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);

//@@@@@@@@@@@@@@@@@@@@@@@@@@@ bitmap section @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        static Bitmap bmp1 = new Bitmap(800, 600);
        Graphics z = Graphics.FromImage(bmp1);

        static Bitmap bm1 = new Bitmap(32, 32);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(32, 32);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(32, 32);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(32, 32);
        Graphics b4 = Graphics.FromImage(bm4);

        static Bitmap bm11 = new Bitmap(32, 32);
        Graphics b11 = Graphics.FromImage(bm11);

        static Bitmap bm12 = new Bitmap(32, 32);
        Graphics b12 = Graphics.FromImage(bm12);

        static Bitmap bm13 = new Bitmap(32, 32);
        Graphics b13 = Graphics.FromImage(bm13);

        static Bitmap bm14 = new Bitmap(32, 32);
        Graphics b14 = Graphics.FromImage(bm14);
        
       //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (start == 0)
            {
                Start();
                start = 1;
            }
            e.Graphics.DrawImage(bmp1, 0, 0);
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            brd[bx, by] = 2;
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;
            
                bx = mx / 16 + 1;
                by = my / 16 + 1;
            
            
            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);
            
            UpdateText();
            UpdateScreen();
            Invalidate();
            Update();
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            score = 9;
        }

        // @@@@@@@@@@@@@@@@@@@@@@@@@@@@

        private void UpdateScreen()
        {
            
            int x = 1;
            int y = 1;
            int a = 1;
            int b = 1;
            
            while (b < 51)
            {
                while (a < 51)
                {
                    
                    
                    if (brd[a, b] == 1) { z.DrawImage(bm1, x , y ); }
                    if (brd[a, b] == 2) { z.DrawImage(bm2, x , y ); }
                    if (brd[a, b] == 3) { z.DrawImage(bm3, x , y ); }
                    if (brd[a, b] == 4) { z.DrawImage(bm4, x , y ); }


                    if (brd2[a, b] == 11) { z.DrawImage(bm11, x + 14, y + 14); }
                    if (brd2[a, b] == 12) { z.DrawImage(bm12, x + 14, y + 14); }
                    if (brd2[a, b] == 13) { z.DrawImage(bm13, x + 14, y + 14); }
                    if (brd2[a, b] == 14) { z.DrawImage(bm14, x + 14, y + 14); }
                    x = x + 16;
                    a = a + 1;
                }
                b = b + 1;
                a = 1;
                x = 1;
                y = y + 16;
            }

    
        }


        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        private void UpdateText()
        {
            z.FillRectangle(br1, 0.0F, 0.0F, 800.0F, 600.0F); //text
            
            //if (gameover < 1) Update();
            //if (gameover < 1) DrawFrame();
            Instructions();
            z.DrawString(cnt.ToString(), myfont, Brushes.White, 10, 380);
            z.DrawString(mx.ToString(), myfont, Brushes.White, 10, 400);
            z.DrawString(my.ToString(), myfont, Brushes.White, 10, 420);
            z.DrawString(bx.ToString(), myfont, Brushes.White, 10, 440);
            z.DrawString(by.ToString(), myfont, Brushes.White, 10, 460);

            z.DrawString("Score  =", myfont, Brushes.White, 10, 40);
            z.DrawString(score.ToString(), myfont, Brushes.White, 100, 40);
        }
        private void Instructions()
        {

            z.DrawString("Click on a block to remove ", font10, Brushes.White, 0, 100);
            z.DrawString("from the board. Click on an", font10, Brushes.White, 0, 118);
            z.DrawString("empty square to put it back.", font10, Brushes.White, 0, 136);
            z.DrawString("There must be a clear path", font10, Brushes.White, 0, 154);
            z.DrawString("between the two points. You", font10, Brushes.White, 0, 172);
            z.DrawString("score points when you get 4", font10, Brushes.White, 0, 190);
            z.DrawString("of the same blocks in a row ", font10, Brushes.White, 0, 208);
            z.DrawString("and they are removed from ", font10, Brushes.White, 0, 226);
            z.DrawString("the board. ", font10, Brushes.White, 0, 244);
            z.DrawString(" ", font10, Brushes.White, 0, 262);
            z.DrawString(" ", font10, Brushes.White, 0, 280);
        }
        private void Start()
        {
            int a = 1;
            int x = 0;
            int y = 0;
            brd[20,20] = 1;
            //timer1.Stop();
            b1.FillRectangle(Brushes.Red, 0.0F, 0.0F, 32.0F, 32.0F);
            b2.FillRectangle(Brushes.Green, 0.0F, 0.0F, 32.0F, 32.0F);
            b3.FillRectangle(Brushes.Blue, 0.0F, 0.0F, 32.0F, 32.0F);
            b4.FillRectangle(Brushes.Violet, 0.0F, 0.0F, 32.0F, 32.0F);

            b1.FillEllipse(Brushes.SlateBlue, 8, 8, 16, 16);
            b2.FillEllipse(Brushes.SlateBlue, 8, 8, 16, 16);
            b3.FillEllipse(Brushes.SlateBlue, 8, 8, 16, 16);
            b4.FillEllipse(Brushes.SlateBlue, 8, 8, 16, 16);
            

            b11.FillRectangle(Brushes.Red, 2.0F, 2.0F, 33.0F, 33.0F);
            b12.FillRectangle(Brushes.LawnGreen, 2.0F, 2.0F, 33.0F, 33.0F);
            b13.FillRectangle(Brushes.Blue, 2.0F, 2.0F, 33.0F, 33.0F);
            b14.FillRectangle(Brushes.Violet, 2.0F, 2.0F, 33.0F, 33.0F);

            start = 1;
            //option = 1;
            //UpdateText();
            //UpdateBoard();
            //DrawFrame();
        }

    }
}